# pymerkletree
[![PyPI version](https://badge.fury.io/py/pymerkletree.svg)](https://badge.fury.io/py/pymerkletree)
[![Build Status](https://travis-ci.org/aliciawyy/pymerkletools.svg?branch=master)](https://travis-ci.org/aliciawyy/pymerkletools)
[![codecov](https://codecov.io/gh/aliciawyy/pymerkletools/branch/master/graph/badge.svg)](https://codecov.io/gh/aliciawyy/pymerkletools)
[![Maintainability](https://api.codeclimate.com/v1/badges/cfa9766c9537f10f72f1/maintainability)](https://codeclimate.com/github/aliciawyy/pymerkletools/maintainability)
[![Updates](https://pyup.io/repos/github/aliciawyy/pymerkletools/shield.svg)](https://pyup.io/repos/github/aliciawyy/pymerkletools/)

This project is adapted from the [pymerkletools](https://github.com/aliciawyy/pymerkletools) of Tierion.

I have refactored and simplified most part of the code so it can be easier for development or for the understanding of MerkleTree.

It includes a `MerkleTree` class for creating Merkle trees, generating merkle proofs, and verification of merkle proofs.

## Installation

```
pip install pymerkletree
```

## Examples

The source code is simple by itself and examples can be found in the folder `demo`.

## Notes

### About tree generation

1. Internally, leaves are stored as `bytearray`. When the tree is built, it is
generated by hashing together the `bytearray` values.
2. Lonely leaf nodes are promoted to the next level up, as depicted below.

                         ROOT=Hash(H+E)
                         /        \
                        /          \
                 H=Hash(F+G)        E
                 /       \           \
                /         \           \
         F=Hash(A+B)    G=Hash(C+D)    E
          /     \        /     \        \
         /       \      /       \        \
        A         B    C         D        E
